// 

import {






  SwapCurrencyError
} from 'edge-core-js/types'

import { makeSwapPluginQuote } from '../swap-helpers.js'

const pluginId = 'transfer'
const swapInfo = {
  pluginId,
  displayName: 'Transfer',

  orderUri: undefined,
  supportEmail: 'support@edge.com'
}

export function makeTransferPlugin(
  opts
) {
  const { log } = opts

  const out = {
    swapInfo,

    async fetchSwapQuote(
      request,
      userSettings
    ) {
      if (request.fromCurrencyCode !== request.toCurrencyCode) {
        throw new SwapCurrencyError(
          swapInfo,
          request.fromCurrencyCode,
          request.toCurrencyCode
        )
      }

      const {
        publicAddress: toAddress
      } = await request.toWallet.getReceiveAddress()

      const tx = await request.fromWallet.makeSpend({
        currencyCode: request.fromCurrencyCode,
        spendTargets: [
          {
            nativeAmount: request.nativeAmount,
            publicAddress: toAddress
          }
        ]
      })

      const quote = makeSwapPluginQuote(
        request,
        request.nativeAmount,
        request.nativeAmount,
        tx,
        toAddress,
        'transfer'
      )
      log(quote)
      return quote
    }
  }

  return out
}
